#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#include <mpi.h>

#define NMAX 100000000

double uvnitr_kruhu(double x, double y)
{
	double r = 0.5;
	
	if (sqrt(x*x + y*y) <= r) return 1.;
	else return 0.;
}

int main(int argc, char **argv)
{
	MPI_Init(&argc, &argv);
	
	int moje_cislo, svet;
	MPI_Comm_rank(MPI_COMM_WORLD, &moje_cislo);
     MPI_Comm_size(MPI_COMM_WORLD, &svet);
     MPI_Status stat;

	int i;
	double celkem = 0., pom = 0.;
	double x, y;
	
	if(!moje_cislo)
	{
		for (i = 1; i < svet; i++)
		{
			MPI_Recv(&pom, 1, MPI_DOUBLE, i, 1, MPI_COMM_WORLD, &stat);
			celkem += pom / (svet - 1);
		}
		
		printf("%f\n", celkem);
	}
	else
	{
		srand(moje_cislo);
		
		for (i = 0; i < NMAX; i++)
		{
			x = (double)rand() / (double)RAND_MAX - 0.5;
			y = (double)rand() / (double)RAND_MAX - 0.5;
			celkem += 4 * uvnitr_kruhu(x, y) / (double)NMAX;
		}
		
		MPI_Send(&celkem, 1, MPI_DOUBLE, 0, 1, MPI_COMM_WORLD);
	}
	
	
	MPI_Finalize();
		
	return 0;
}

