#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#include <mpi.h>

#define NMAX 100000000

double uvnitr_kruhu(double x, double y)
{
	double r = 0.5;
	
	if (sqrt(x*x + y*y) <= r) return 1.;
	else return 0.;
}

int main(int argc, char **argv)
{
	MPI_Init(&argc, &argv);
	
	int moje_cislo, svet;
	MPI_Comm_rank(MPI_COMM_WORLD, &moje_cislo);
     MPI_Comm_size(MPI_COMM_WORLD, &svet);
     MPI_Status stat;

	int i;
	double celkem = 0., pom = 0.;
	double x, y;
	
	srand(moje_cislo + 1);
	
	for (i = 0; i < NMAX; i++)
	{
		x = (double)rand() / (double)RAND_MAX - 0.5;
		y = (double)rand() / (double)RAND_MAX - 0.5;
		celkem += 4*uvnitr_kruhu(x, y) / (double)NMAX;
	}
	
	MPI_Reduce(&celkem, &pom, 1, MPI_DOUBLE, MPI_SUM, 0, MPI_COMM_WORLD);
	
	//if(!moje_cislo)
//	{				
		printf("%f, id %d\n", pom / (double)svet, moje_cislo);
	//};
		
	
	MPI_Finalize();
		
	return 0;
}

